/**
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Jianfeng Gao ( jianfeng dot gao at kit dot edu )
 * @date       2022
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include "armarx/control/njoint_mp_controller/task_space/ImpedanceController.h"
#include "armarx/control/njoint_mp_controller/task_space/AdmittanceController.h"
#include <armarx/control/njoint_mp_controller/task_space/KVILImpedanceController.h>

#include <armarx/control/client/ControllerDescription.h>
#include <armarx/control/njoint_mp_controller/task_space/aron/NJointMPControllerConfig.aron.generated.h>
#include <armarx/control/common/type.h>


namespace armarx::control::client
{
    template <>
    struct ControllerDescription<armarx::control::common::ControllerType::TSImpedanceMP>
    {
        using AronDTO =
                armarx::control::njoint_mp_controller::task_space::arondto::TSImpedanceMPConfig;

        using BO = armarx::control::njoint_mp_controller::task_space::TSImpedanceMPConfig;

        constexpr static const char* name = "NJointTSImpedanceMPController";
    };

    template <>
    struct ControllerDescription<armarx::control::common::ControllerType::TSAdmittanceMP>
    {
        using AronDTO =
                armarx::control::njoint_mp_controller::task_space::arondto::TSAdmittanceMPConfig;

        using BO = armarx::control::njoint_mp_controller::task_space::TSAdmittanceMPConfig;

        constexpr static const char* name = "NJointTSAdmittanceMPController";
    };

    template <>
    struct ControllerDescription<armarx::control::common::ControllerType::KVILImpedanceMP>
    {
        using AronDTO =
                armarx::control::njoint_mp_controller::task_space::arondto::KVILImpedanceMPConfig;

        using BO = armarx::control::njoint_mp_controller::task_space::KVILImpedanceMPConfig;

        constexpr static const char* name = "NJointKVILImpedanceMPController";
    };


} /// namespace armarx::control::client
